<template>
	<v-dialog v-model="dialog" max-width="500" persistent>
		<v-card>
			<v-card-title>Para: {{name}}</v-card-title>
			<v-card-text>
				<v-row>
					<v-col cols="12">
						<v-textarea v-model="message" filled label="Ingrese el mensaje" clearable />
					</v-col>
				</v-row>
			</v-card-text>
			<v-card-actions>
				<v-row justify="space-around">
					<v-col cols="12" sm="4">
						<v-btn
							:disabled="disabledButton"
							:loading="loading"
							block
							color="green"
							outlined
							@click="sendMessage"
						>
							Enviar
							<template v-slot:loader>
								<span>Enviando...</span>
							</template>
						</v-btn>
					</v-col>
					<v-col cols="12" sm="4">
						<v-btn block color="red" outlined @click="closeForm">Cancelar</v-btn>
					</v-col>
				</v-row>
			</v-card-actions>
		</v-card>
	</v-dialog>
</template>

<script>
import EventBus from "../../bus";
import gql from "graphql-tag";

export default {
	name: "FormCustomMessage",
	props: ["dialog"],
	data: () => ({
		loading: false,
		disabledButton: false,
		name: "",
		message: ""
	}),
	methods: {
		// cierra el formulario
		closeForm() {
			EventBus.$emit("closeFormCustomMessage");
			this.message = "";
		},
		// Envia el mensaje personalizado
		async sendMessage() {
			try {
				await this.$apollo.mutate({
					mutation: gql`
						mutation($curp: String!, $message: String!) {
							sendMessage(curp: $curp, message: $message)
						}
					`,
					variables: {
						curp: this.$route.params.student,
						message: this.message
					}
				});
				this.loading = true;
				setTimeout(() => {
					this.loading = false;
					EventBus.$emit("succSendMessage");
					this.disabledButton = true;
					setTimeout(() => {
						this.closeForm();
						this.disabledButton = false;
					}, 2000);
				}, 2000);
			} catch (error) {}
		}
	},
	created() {
		EventBus.$on("sendName", name => {
			this.name = name;
		});
	},
	mounted() {
		// cierra el formulario de registro con la tecla ESC
		document.addEventListener("keydown", event => {
			const keyWhich = event.which;
			if (keyWhich == 27) {
				this.closeForm();
			}
		});
	}
};
</script>